/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
  USBFS豸ļöٹ̣
  OTG_FS_DM(PA11)OTG_FS_DP(PA12)

*/
#include "debug.h"
#include "stdio.h"
#include "string.h"
#include "ch32vf20x_usbotg_host.h"
#include "CHRV3UFI.h"

__attribute__ ((aligned(16))) UINT8   buf[ 128 ];  // OUT, must even address

/* ״̬,ʾ벢ͣ */
void mStopIfError( UINT8 iError )
{
    if ( iError == ERR_SUCCESS )
    {
        return;    /* ɹ */
    }
    printf( "Error:%02x\r\n", iError );  /* ʾ */
    /* ,Ӧ÷ԼCHRV3DiskStatus״̬,CHRV3DiskReadyѯǰUǷ,UѶϿôµȴU̲ٲ,
         Ĵ:
         1һCHRV3DiskReady,ɹ,Open,Read/Write
         2CHRV3DiskReadyɹ,ôǿнͷʼ */
    while(1)
    {  }
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    UINT8 s;
    UINT8 flg=1;
    UINT8 ret;
    UINT8 i,t;
    UINT16 TotalCount = 0;
    USART_Printf_Init(115200);
    Delay_Init( );
    printf("SystemClk:%d\r\n",SystemCoreClock);
    printf("USBFS HOST Test EXAM 1\r\n");

    USBOTG_HostInit(ENABLE);

    ret = CHRV3LibInit();
    if( ret == ERR_SUCCESS )
    {
        printf( "UDisk Lib Init Success\n" );
    }
    else
    {
        printf( "UDisk Lib Init ERR Code %02x\n", ret );
        while(1);
    }

    while(1)
    {
        while(flg)
        {
            s = ERR_SUCCESS;
            if ( USBOTG_FS->INT_FG & USBHD_UIF_DETECT )
            {
                USBOTG_FS->INT_FG = USBHD_UIF_DETECT ;

                s = AnalyzeRootHub( );
                if ( s == ERR_USB_CONNECT )
                {
                    printf( "New Device In\r\n" );
                    FoundNewDev = 1;

                }
                if( s == ERR_USB_DISCON )
                {
                    printf( "Device Out\r\n" );
                }
            }

            if ( FoundNewDev || s == ERR_USB_CONNECT )
            {
                FoundNewDev = 0;
                Delay_Ms( 200 );
                s = USBOTG_HostEnum( buf );
                if ( s == ERR_SUCCESS )
                {
                    printf( "Device Enum Succeed\r\n" );
                    flg=0;
                    // U̲̣USB߸λUӡȡ豸USBַѡĻȡ֮󵽴˴CH103ӳɺ
                    CHRV3DiskStatus = DISK_USB_ADDR;
                    for ( i = 0; i != 10; i ++ )
                    {
                          printf( "Wait DiskReady\r\n" );
                          ret = CHRV3DiskReady( );                                 //ȴU׼
                          if ( ret == ERR_SUCCESS )
                          {
                              printf("CHRV3DiskStatus:%02x\r\n",CHRV3DiskStatus);
                              /* ļ */
                              strcpy( (PCHAR)mCmdParam.Open.mPathName, "/C51/NEWFILE.C" );     //ýҪļ·ļ/C51/NEWFILE.C
                              ret = CHRV3FileOpen( );                                       //ļ
                              if ( ret == ERR_MISS_DIR || ret == ERR_MISS_FILE )            //ûҵļ
                              {
                                  //ļʾ
                                  printf( "Find No File And Create\r\n" );
                                  strcpy( (PCHAR)mCmdParam.Create.mPathName, "/C51/NEWFILE.C" );          /* ļ,ڸĿ¼,ļ */
                                  ret = CHRV3FileCreate( );                                        /* ½ļ,ļѾɾ½ */
//                                  mStopIfError( ret );
                                  printf( "ByteWrite\r\n" );
                                  //ʵӦждݳȺͶ建ǷڻҪд
                                  i = sprintf( (PCHAR)buf,"Note: \xd\xaֽΪλUļд,ʾܡ\xd\xa");  /*ʾ */
                                  for(t=0; t<10; t++)
                                  {
                                      mCmdParam.ByteWrite.mByteCount = i;                          /* ָдֽ */
                                      mCmdParam.ByteWrite.mByteBuffer = buf;                       /* ָ򻺳 */
                                      ret = CHRV3ByteWrite( );                                       /* ֽΪλļд */
//                                      mStopIfError( ret );
                                      printf("\r\nɹд %02X\r\n",(UINT16)t);
                                  }
                                  //ʾ޸ļ
                                  printf( "Modify\r\n" );
                                  mCmdParam.Modify.mFileAttr = 0xff;   //: µļ,Ϊ0FFH޸
                                  mCmdParam.Modify.mFileTime = 0xffff;   //: µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
                                  mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2015, 5, 18 );  //: µļ: 2015.05.18
                                  mCmdParam.Modify.mFileSize = 0xffffffff;  // : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
                                  i = CHRV3FileModify( );   //޸ĵǰļϢ,޸
//                                  mStopIfError( i );
                                  printf( "Close\r\n" );
                                  mCmdParam.Close.mUpdateLen = 1;     /* Զļ,ֽΪλдļ,óرļԱԶļ */
                                  i = CHRV3FileClose( );
//                                  mStopIfError( i );

                                  /* ɾĳļ */
//                                  printf( "Erase\n" );
//                                  strcpy( (PCHAR)mCmdParam.Create.mPathName, "/OLD" );  //ɾļ,ڸĿ¼
//                                  i = CHRV3FileErase( );  //ɾļر
//                                  if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  //ʾ
                              }
                              else
                              {
                                  //ϣӵԭļβ,ƶļָ
                                ///////////һдļ/////////////////////////////////////////
                                  printf( "ByteWrite\r\n" );
                                  mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  //Ƶļβ
                                  CHRV3ByteLocate( );
                                //ʵӦждݳȺͶ建ǷڻҪд
                                  i = sprintf( (PCHAR)buf,"Note: \xd\xaֽΪλUļд,ʾܡ\xd\xa");  /*ʾ */
                                  for(t=0; t<10; t++)
                                  {
                                      mCmdParam.ByteWrite.mByteCount = i;                          /* ָдֽ */
                                      mCmdParam.ByteWrite.mByteBuffer = buf;                       /* ָ򻺳 */
                                      ret = CHRV3ByteWrite( );                                       /* ֽΪλļд */
//                                      mStopIfError( ret );
                                      printf("ɹд %02X",(UINT16)t);
                                  }

                                  ///////////ȡļǰNֽ/////////////////////////////////////////
                                  TotalCount = 100;                                      //׼ȡܳ100ֽ
                                  printf( "ǰ%dַ:\r\n",TotalCount );
                                  while ( TotalCount ) {                                 //ļȽϴ,һζ,ٵCH103ByteReadȡ,ļָԶƶ
                                      if ( TotalCount > (MAX_PATH_LEN-1) ) t = MAX_PATH_LEN-1;/* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.Other.mBuffer ) */
                                      else t = TotalCount;                                 /* ʣֽ */
                                      mCmdParam.ByteRead.mByteCount = t;                   /* ʮֽ */
                                      mCmdParam.ByteRead.mByteBuffer= &buf[0];
                                      ret = CHRV3ByteRead( );                                /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
                                      TotalCount -= mCmdParam.ByteRead.mByteCount;           /* ,ȥǰʵѾַ */
                                      for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%c", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
                                      if ( mCmdParam.ByteRead.mByteCount < t ) {             /* ʵʶַҪַ,˵ѾļĽβ */
                                          printf( "\r\n" );
                                          printf( "ļѾ\r\n" );
                                          break;
                                      }
                                  }

                                ///////////ָλöȡļNֽ/////////////////////////////////////////
                                  i = CHRV3FileClose( );                                    /* رļ */
//                                  mStopIfError( i );
                              }
                              break;
                          }
                          else
                          {
                              printf("ret = %02x\r\n",ret);
                              printf("CHRV3DiskStatus:%02x\n",CHRV3DiskStatus);
                          }
//                          Delay_Ms( 50 );
                      }
                }
                else
                {
                    printf( "Device Enum Failed\r\n" );
                }
            }
        }
    }
    while(1);
}

