/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
  USBFS豸ļöٹ̣
  OTG_FS_DM(PA11)OTG_FS_DP(PA12)

*/
#include "debug.h"
#include "stdio.h"
#include "string.h"
#include "ch32vf20x_usbotg_host.h"
#include "CHRV3UFI.h"

__attribute__ ((aligned(4))) UINT8   buf[ 128 ];  // OUT, must even address
__attribute__ ((aligned(4))) UINT8   MY_DATA_BUF[ DISK_BASE_BUF_LEN ];   /* MY_DATA_BUFָⲿRAMĴݻ,Ϊһĳ,ûݻ*/

/* ״̬,ʾ벢ͣ */
void mStopIfError( UINT8 iError )
{
    if ( iError == ERR_SUCCESS )
    {
        return;    /* ɹ */
    }
    printf( "Error:%02x\r\n", iError );  /* ʾ */
    /* ,Ӧ÷ԼCHRV3DiskStatus״̬,CHRV3DiskReadyѯǰUǷ,UѶϿôµȴU̲ٲ,
         Ĵ:
         1һCHRV3DiskReady,ɹ,Open,Read/Write
         2CHRV3DiskReadyɹ,ôǿнͷʼ */
    while(1)
    {  }
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    UINT8  flg;
    UINT8  ret, s;
    UINT8  i;
    UINT8  *pCodeStr;
    UINT16 j;


    USART_Printf_Init(115200);
    Delay_Init( );
    printf("SystemClk:%d\r\n",SystemCoreClock);
    printf("USBFS HOST Test EXAM 11\r\n");

    USBOTG_HostInit(ENABLE);

    ret = CHRV3LibInit();
    if( ret == ERR_SUCCESS )
    {
        printf( "UDisk Lib Init Success\n" );
    }
    else
    {
        printf( "UDisk Lib Init ERR Code %02x\n", ret );
        while(1);
    }

    while(1)
    {
        s = ERR_SUCCESS;
        if ( USBOTG_FS->INT_FG & USBHD_UIF_DETECT )
        {
            USBOTG_FS->INT_FG = USBHD_UIF_DETECT ;

            s = AnalyzeRootHub( );
            if ( s == ERR_USB_CONNECT )
            {
                printf( "New Device In\r\n" );
                FoundNewDev = 1;
                flg = 1;
            }
            if( s == ERR_USB_DISCON )
            {
                printf( "Device Out\r\n" );
            }
        }

        if ( FoundNewDev || s == ERR_USB_CONNECT )
        {
            FoundNewDev = 0;
            Delay_Ms( 200 );
            s = USBOTG_HostEnum( buf );
            if ( s == ERR_SUCCESS )
            {
                printf( "Enum Succeed\r\n" );
                Delay_Ms(100);
                // U̲̣USB߸λUӡȡ豸USBַѡĻȡ֮󵽴˴CH103ӳɺ
                CHRV3DiskStatus = DISK_USB_ADDR;
                for ( i = 0; i != 10; i ++ )
                {
                    printf( "Wait DiskReady\r\n" );
                    s = CHRV3DiskReady( );                                 //ȴU׼
                    if ( s == ERR_SUCCESS )
                    {
                        /* ȡԭļ */
                        printf( "Open\r\n" );
                        strcpy( mCmdParam.Open.mPathName, "/C51/CHRV3HFT.C" );//ļ,ļC51Ŀ¼
                        s = CHRV3FileOpen( );                        //ļ
                        /* гļ */
                        if ( s == ERR_MISS_DIR )
                        {
                            printf("ڸļгļ\r\n");  //C51Ŀ¼гĿ¼µļ
                            pCodeStr = "/*";
                        }
                        else
                        {
                            pCodeStr = "/C51/*";                     //* CHRV3HFT.Cļг\C51Ŀ¼µCHRV3ͷļ
                        }
                        printf( "List file %s\r\n", pCodeStr );
                        for ( j = 0; j < 10000; j ++ )               //ǰ10000ļ,ʵû
                        {
                            strcpy( mCmdParam.Open.mPathName, pCodeStr );//ļ,*Ϊͨ,ļĿ¼
                            i = strlen( mCmdParam.Open.mPathName );
                            mCmdParam.Open.mPathName[ i ] = 0xFF;    //ַȽ滻Ϊ,0254,0xFF255˵CHRV3vFileSize
                            CHRV3vFileSize = j;                      //ָ/öٵ
                            i = CHRV3FileOpen( );                    //ļ,ļкͨ*,Ϊļ
                            /* CHRV3FileEnum  CHRV3FileOpen Ψһǵ߷ERR_FOUND_NAMEʱôӦǰ߷ERR_SUCCESS */
                            if ( i == ERR_MISS_FILE )
                            {
                                break;                                //Ҳƥļ,Ѿûƥļ
                            }
                            if ( i == ERR_FOUND_NAME )
                            {
                                /* ͨƥļ,ļ· */
                                printf( "  match file %04d#: %s\r\n", (unsigned int)j, mCmdParam.Open.mPathName );//ʾźƥļĿ¼
                                continue;                             //һƥļ,´ʱŻ1
                            }
                            else
                            {
                                /*  */
                                mStopIfError( i );
                                break;
                            }
                        }
                        printf( "Close\r\n" );
                        i = CHRV3FileClose( );                         //رļ
                        printf( "Uʾ\r\n" );
                        break;
                    }
                    else
                    {
                        printf("s = %02x\r\n",s);
                        printf("CHRV3DiskStatus:%02x\r\n",CHRV3DiskStatus);
                    }
                }
            }
            else
            {
                printf( "Device Enum Failed\r\n" );
            }
        }
    }
}

